/* (i/u)toa_width() test with table of patterns. Base is 8.	*/
#include <stdlib.h>
#include <string.h>
#include "xtoa_fast.h"

#define SIZEMAX     10

/* Compare with pattern.	*/
static int
cmp (unsigned int val, int flags, size_t width, const char * pattern)
{
    char s[SIZEMAX];
    char *p;
    
    p = itoa_width (val, s, flags | 8, width);
    if (p != s) return 1;
    if (strcmp(s, pattern)) return 1;

    p = utoa_width (val, s, flags | 8, width);
    if (p != s) return 1;
    if (strcmp(s, pattern)) return 1;

    return 0;
}

int main ()
{
    static struct t_s {
	int val;
	int flags;
	unsigned char width;
	char s[SIZEMAX];
    } t[] = {

	{ 0, 0, 1,	"0" },
	{ 0, 0, 2,	"00" },
	{ 0, 0, 9,	"000000000" },
	
	{ 1, 0, 1,	"1" },
	{ 1, 0, 2,	"01" },
	{ 1, 0, 9,	"000000001" },
	
	{ -1, 0, 5,	"177777" },
	{ -1, 0, 6,	"177777" },
	{ -1, 0, 7,	"0177777" },
	{ -1, 0, 9,	"000177777" },
	
	{ 010, 0, 2,		"10" },
	{ 010, 0, 3,		"010" },
	{ 0100, 0, 3,		"100" },
	{ 0100, 0, 4,		"0100" },
	{ 01000, 0, 4,		"1000" },
	{ 01000, 0, 5,		"01000" },
	{ 010000, 0, 5,		"10000" },
	{ 010000, 0, 6,		"010000" },
	{ 0100000, 0, 6,	"100000" },
	{ 0100000, 0, 7,	"0100000" },
	
	{ 0, XTOA_PREFIX, 0,	"0" },
	{ 0, XTOA_PREFIX, 1,	"0" },
	{ 0, XTOA_PREFIX, 2,	"00" },
	
	{ 1, XTOA_PREFIX, 0,	"01" },
	{ 1, XTOA_PREFIX, 1,	"01" },
	{ 1, XTOA_PREFIX, 2,	"01" },
	{ 1, XTOA_PREFIX, 3,	"001" },
	
	{ -1, XTOA_PREFIX, 6,	"0177777" },
	{ -1, XTOA_PREFIX, 7,	"0177777" },
	{ -1, XTOA_PREFIX, 8,	"00177777" },
    };
    struct t_s *p;
    int i;
    
    i = 0;
    for (p = t; p != t + sizeof(t)/sizeof(t[0]); p++) {
	i += 1;
	if (cmp(p->val, p->flags, p->width, p->s))
	    exit(i);
    }
    
    return 0;
}
