/* ltoa_fast() test with table #1 of patterns.  Basis are: 8,10,16.
   RAM restriction is a reason of spliting.	*/
#include <stdlib.h>
#include <string.h>
#include "xtoa_fast.h"

/* Compare with pattern.	*/
static int cmp (long val, int base, const char * pattern)
{
    char s[13];
    char *p;
    
    p = ltoa_fast (val, s, base);
    if (p != s) return 1;
    if (strcmp(s, pattern)) return 2;
    return 0;
}

int main ()
{
    static struct t_s {
	long val;
	int base;
	char s[13];		/* pattern	*/
    } t[] = {

	{ 0, 10,	"0" },
	{ 0, 8,		"0" },
	{ 0, 16,	"0" },
	
	{ 1, 10,	"1" },
	{ 1, 8,		"1" },
	{ 1, 16,	"1" },
	
	{ 0x7fffffff,	10, "2147483647" },
	{ 0x7fffffff,	8, "17777777777" },
	{ 0x7fffffff,	16,   "7fffffff" },
	
	{ -1, 10,	"-1" },
	{ -1, 8,	"37777777777" },
	{ -1, 16,	"ffffffff" },
	
	{ 0x80000000,	10, "-2147483648" },
	{ 0x80000000,	8,  "20000000000" },
	{ 0x80000000,	16,    "80000000" },

	{ 0x80000001,	10, "-2147483647" },
	{ 0x80000001,	8,  "20000000001" },
	{ 0x80000001,	16,    "80000001" },

    };
    struct t_s *p;
    int i;
    
    i = 0;
    for (p = t; p != t + sizeof(t)/sizeof(t[0]); p++) {
	i += 1;
	if (cmp(p->val, p->base, p->s))
	    exit(i);
    }
    
    return 0;
}
