/* Printf octals, int.
 */
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void run (unsigned x)
{
    char s [sizeof("177777")];
    unsigned char r1;
    size_t n;
    unsigned long y;
    char *p;
    
    x &= 0xffff;		/* for "test of test"	*/
    sprintf (s, "%o", x);
    
#ifdef	TEST_OF_TEST
    (void)r1;
#else
    /* r1 ? (it is used in asm subroutine)	*/
    asm ("mov %0,r1" : "=r"(r1));
    if (r1) exit (__LINE__);
#endif

    /* strlen(s) ?	*/
    n = strlen(s);
    if (x < 010) {
	if (n != 1) exit (__LINE__);
    } else if (x < 0100) {
	if (n != 2) exit (__LINE__);
    } else if (x < 01000) {
	if (n != 3) exit (__LINE__);
    } else if (x < 010000) {
	if (n != 4) exit (__LINE__);
    } else if (x < 0100000) {
	if (n != 5) exit (__LINE__);
    } else {
	if (n != 6) {
#ifdef	TEST_OF_TEST
	    fprintf (stderr, "x= %#x  s= \"%s\"\n", x, s);
#endif
	    exit (__LINE__);
	}
    }

    /* back ?	*/
    errno = 0;
    y = strtoul(s, & p, 8);
    if (errno || *p) exit (__LINE__);
    if (y != x) exit (__LINE__);
}

void run2 (unsigned x)
{
    run (x);
    run (~x);
}

int main ()
{
    unsigned int x;
    int i;

    run2 (0);
    run2 (0123456);
    run2 (0x5555);
    
    for (x= 1; x & 0xffff; x <<= 1)
	run2 (x);
    for (x= 3; x & 0xffff; x <<= 1)
	run2 (x);
    for (x= 7; x & 0xffff; x <<= 1)
	run2 (x);

    for (x= 0, i= 7; i; i--)
	run2 (x += 0111111);
	
    for (x= 0; x <= 020; x++)
	run2 (x);
    for (x= 0177777; x >= 0177760; x--)
	run2 (x);

    srand (3);
    for (i= 100; i; i--)
	run2 (rand());

    return 0;
}
