/* Printf octals, long.
 */
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void run (unsigned long x)
{
    char s[12];
    unsigned char r1;
    size_t n;
    unsigned long y;
    char *p;
    
    sprintf (s, "%lo", x);
    
#ifdef	TEST_OF_TEST
    (void)r1;
#else
    /* r1 ? (it is used in asm subroutine)	*/
    asm ("mov %0,r1" : "=r"(r1));
    if (r1) exit (__LINE__);
#endif

    /* strlen(s) ?	*/
    n = strlen(s);
    if (x < 010) {
	if (n != 1) exit (__LINE__);
    } else if (x < 0100) {
	if (n != 2) exit (__LINE__);
    } else if (x < 01000) {
	if (n != 3) exit (__LINE__);
    } else if (x < 010000) {
	if (n != 4) exit (__LINE__);
    } else if (x < 0100000) {
	if (n != 5) exit (__LINE__);
    } else if (x < 01000000) {
	if (n != 6) exit (__LINE__);
    } else if (x < 010000000) {
	if (n != 7) exit (__LINE__);
    } else if (x < 0100000000) {
	if (n != 8) exit (__LINE__);
    } else if (x < 01000000000) {
	if (n != 9) exit (__LINE__);
    } else if (x < 010000000000) {
	if (n != 10) exit (__LINE__);
    } else {
	if (n != 11) {
	    exit (__LINE__);
	}
    }

    /* invert ?	*/
    errno = 0;
    y = strtoul(s, & p, 8);
    if (errno || *p) exit (__LINE__);
    if (y != x) exit (__LINE__);
}

void run2 (unsigned long x)
{
    run (x);
    run (~x);
}

int main ()
{
    unsigned long x;
    int i;

    run2 (0);
    run2 (012345670123);
    run2 (0x55555555);
    
    for (x= 1; x; x <<= 1)
	run2 (x);
    for (x= 3; x; x <<= 1)
	run2 (x);
    for (x= 7; x; x <<= 1)
	run2 (x);

    for (x= 0, i= 7; i; i--)
	run2 (x += 011111111111);

    for (x= 0; x <= 0100; x++)
	run2 (x);
    for (x= 037777777777; x >= 037777777700; x--)
	run2 (x);

    srand (4);
    for (i= 1000; i; i--)
	run2 (rand() ^ ((long)rand() << 16));

    return 0;
}
